commit 166cb9e9f48ca1e05ea3c4579b50f87ffb674f50
Author: Silentkiller159 <milanhotovec@seznam.cz>
Date:   Thu May 13 22:33:24 2021 +0200

    Completed data layer with migrations. With flags

diff --git a/src/Core/Infrastructure/Leuze.Core.Infrastructure.Persistence/Migrations/20210513145537_Added-GlobalArea.cs b/src/Core/Infrastructure/Leuze.Core.Infrastructure.Persistence/Migrations/20210513145537_Added-GlobalArea.cs
new file mode 100644
index 0000000..f50254e
--- /dev/null
+++ b/src/Core/Infrastructure/Leuze.Core.Infrastructure.Persistence/Migrations/20210513145537_Added-GlobalArea.cs
@@ -0,0 +1,160 @@
+﻿using System;
+using Microsoft.EntityFrameworkCore.Migrations;
+
+namespace Leuze.Core.Infrastructure.Persistence.Migrations
+{
+    public partial class AddedGlobalArea : Migration
+    {
+        protected override void Up(MigrationBuilder migrationBuilder)
+        {
+            migrationBuilder.DropColumn(
+                name: "From",
+                table: "Leuze_Modules_Goal_Domain_GoalDefinitions");
+
+            migrationBuilder.DropColumn(
+                name: "To",
+                table: "Leuze_Modules_Goal_Domain_GoalDefinitions");
+
+            migrationBuilder.DropColumn(
+                name: "Vari",
+                table: "Leuze_Modules_Goal_Domain_GoalDefinitions");
+
+            migrationBuilder.AlterColumn<double>(
+                name: "PercentileUser",
+                table: "Leuze_Modules_Goal_Domain_GoalItems",
+                type: "float",
+                nullable: false,
+                oldClrType: typeof(decimal),
+                oldType: "decimal(18,2)");
+
+            migrationBuilder.AlterColumn<double>(
+                name: "PercentileFinal",
+                table: "Leuze_Modules_Goal_Domain_GoalItems",
+                type: "float",
+                nullable: false,
+                oldClrType: typeof(decimal),
+                oldType: "decimal(18,2)");
+
+            migrationBuilder.AddColumn<double>(
+                name: "FinanceBase",
+                table: "Leuze_Modules_Goal_Domain_GoalDefinitions",
+                type: "float",
+                nullable: false,
+                defaultValue: 0.0);
+
+            migrationBuilder.AddColumn<Guid>(
+                name: "GDAreaId",
+                table: "Leuze_Modules_Goal_Domain_GoalDefinitions",
+                type: "uniqueidentifier",
+                nullable: false,
+                defaultValue: new Guid("00000000-0000-0000-0000-000000000000"));
+
+            migrationBuilder.AddColumn<double>(
+                name: "VariProjectHours",
+                table: "Leuze_Modules_Goal_Domain_GoalDefinitions",
+                type: "float",
+                nullable: true);
+
+            migrationBuilder.CreateTable(
+                name: "Leuze_Modules_Goal_Domain_GoalDefinitionAreas",
+                columns: table => new
+                {
+                    Id = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
+                    CreatorId = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
+                    From = table.Column<DateTime>(type: "datetime2", nullable: false),
+                    To = table.Column<DateTime>(type: "datetime2", nullable: false),
+                    VariCompanySuccess = table.Column<double>(type: "float", nullable: true)
+                },
+                constraints: table =>
+                {
+                    table.PrimaryKey("PK_Leuze_Modules_Goal_Domain_GoalDefinitionAreas", x => x.Id);
+                    table.ForeignKey(
+                        name: "FK_Leuze_Modules_Goal_Domain_GoalDefinitionAreas_Leuze_Domain_Users_CreatorId",
+                        column: x => x.CreatorId,
+                        principalTable: "Leuze_Domain_Users",
+                        principalColumn: "UserId",
+                        onDelete: ReferentialAction.Cascade);
+                });
+
+            migrationBuilder.CreateIndex(
+                name: "IX_Leuze_Modules_Goal_Domain_GoalDefinitions_GDAreaId",
+                table: "Leuze_Modules_Goal_Domain_GoalDefinitions",
+                column: "GDAreaId");
+
+            migrationBuilder.CreateIndex(
+                name: "IX_Leuze_Modules_Goal_Domain_GoalDefinitionAreas_CreatorId",
+                table: "Leuze_Modules_Goal_Domain_GoalDefinitionAreas",
+                column: "CreatorId");
+
+            migrationBuilder.AddForeignKey(
+                name: "FK_Leuze_Modules_Goal_Domain_GoalDefinitions_Leuze_Modules_Goal_Domain_GoalDefinitionAreas_GDAreaId",
+                table: "Leuze_Modules_Goal_Domain_GoalDefinitions",
+                column: "GDAreaId",
+                principalTable: "Leuze_Modules_Goal_Domain_GoalDefinitionAreas",
+                principalColumn: "Id",
+                onDelete: ReferentialAction.Cascade);
+        }
+
+        protected override void Down(MigrationBuilder migrationBuilder)
+        {
+            migrationBuilder.DropForeignKey(
+                name: "FK_Leuze_Modules_Goal_Domain_GoalDefinitions_Leuze_Modules_Goal_Domain_GoalDefinitionAreas_GDAreaId",
+                table: "Leuze_Modules_Goal_Domain_GoalDefinitions");
+
+            migrationBuilder.DropTable(
+                name: "Leuze_Modules_Goal_Domain_GoalDefinitionAreas");
+
+            migrationBuilder.DropIndex(
+                name: "IX_Leuze_Modules_Goal_Domain_GoalDefinitions_GDAreaId",
+                table: "Leuze_Modules_Goal_Domain_GoalDefinitions");
+
+            migrationBuilder.DropColumn(
+                name: "FinanceBase",
+                table: "Leuze_Modules_Goal_Domain_GoalDefinitions");
+
+            migrationBuilder.DropColumn(
+                name: "GDAreaId",
+                table: "Leuze_Modules_Goal_Domain_GoalDefinitions");
+
+            migrationBuilder.DropColumn(
+                name: "VariProjectHours",
+                table: "Leuze_Modules_Goal_Domain_GoalDefinitions");
+
+            migrationBuilder.AlterColumn<decimal>(
+                name: "PercentileUser",
+                table: "Leuze_Modules_Goal_Domain_GoalItems",
+                type: "decimal(18,2)",
+                nullable: false,
+                oldClrType: typeof(double),
+                oldType: "float");
+
+            migrationBuilder.AlterColumn<decimal>(
+                name: "PercentileFinal",
+                table: "Leuze_Modules_Goal_Domain_GoalItems",
+                type: "decimal(18,2)",
+                nullable: false,
+                oldClrType: typeof(double),
+                oldType: "float");
+
+            migrationBuilder.AddColumn<DateTime>(
+                name: "From",
+                table: "Leuze_Modules_Goal_Domain_GoalDefinitions",
+                type: "datetime2",
+                nullable: false,
+                defaultValue: new DateTime(1, 1, 1, 0, 0, 0, 0, DateTimeKind.Unspecified));
+
+            migrationBuilder.AddColumn<DateTime>(
+                name: "To",
+                table: "Leuze_Modules_Goal_Domain_GoalDefinitions",
+                type: "datetime2",
+                nullable: false,
+                defaultValue: new DateTime(1, 1, 1, 0, 0, 0, 0, DateTimeKind.Unspecified));
+
+            migrationBuilder.AddColumn<decimal>(
+                name: "Vari",
+                table: "Leuze_Modules_Goal_Domain_GoalDefinitions",
+                type: "decimal(18,2)",
+                nullable: true);
+        }
+    }
+}
diff --git a/src/Core/Infrastructure/Leuze.Core.Infrastructure.Persistence/Migrations/20210513201935_Added-CreatedAt.cs b/src/Core/Infrastructure/Leuze.Core.Infrastructure.Persistence/Migrations/20210513201935_Added-CreatedAt.cs
new file mode 100644
index 0000000..6bdaa51
--- /dev/null
+++ b/src/Core/Infrastructure/Leuze.Core.Infrastructure.Persistence/Migrations/20210513201935_Added-CreatedAt.cs
@@ -0,0 +1,102 @@
+﻿using System;
+using Microsoft.EntityFrameworkCore.Migrations;
+
+namespace Leuze.Core.Infrastructure.Persistence.Migrations
+{
+    public partial class AddedCreatedAt : Migration
+    {
+        protected override void Up(MigrationBuilder migrationBuilder)
+        {
+            migrationBuilder.AddColumn<DateTime>(
+                name: "CreatedAt",
+                table: "Leuze_Modules_Goal_Domain_Reviews",
+                type: "datetime2",
+                nullable: false,
+                defaultValue: new DateTime(1, 1, 1, 0, 0, 0, 0, DateTimeKind.Unspecified));
+
+            migrationBuilder.AddColumn<DateTime>(
+                name: "CreatedAt",
+                table: "Leuze_Modules_Goal_Domain_GoalUpdates",
+                type: "datetime2",
+                nullable: false,
+                defaultValue: new DateTime(1, 1, 1, 0, 0, 0, 0, DateTimeKind.Unspecified));
+
+            migrationBuilder.AddColumn<DateTime>(
+                name: "CreatedAt",
+                table: "Leuze_Modules_Goal_Domain_GoalItems",
+                type: "datetime2",
+                nullable: false,
+                defaultValue: new DateTime(1, 1, 1, 0, 0, 0, 0, DateTimeKind.Unspecified));
+
+            migrationBuilder.AddColumn<bool>(
+                name: "OwnerLocked",
+                table: "Leuze_Modules_Goal_Domain_GoalItems",
+                type: "bit",
+                nullable: false,
+                defaultValue: false);
+
+            migrationBuilder.AddColumn<bool>(
+                name: "SupervisorLocked",
+                table: "Leuze_Modules_Goal_Domain_GoalItems",
+                type: "bit",
+                nullable: false,
+                defaultValue: false);
+
+            migrationBuilder.AddColumn<DateTime>(
+                name: "CreatedAt",
+                table: "Leuze_Modules_Goal_Domain_GoalDefinitions",
+                type: "datetime2",
+                nullable: false,
+                defaultValue: new DateTime(1, 1, 1, 0, 0, 0, 0, DateTimeKind.Unspecified));
+
+            migrationBuilder.AddColumn<DateTime>(
+                name: "CreatedAt",
+                table: "Leuze_Modules_Goal_Domain_GoalDefinitionAreas",
+                type: "datetime2",
+                nullable: false,
+                defaultValue: new DateTime(1, 1, 1, 0, 0, 0, 0, DateTimeKind.Unspecified));
+
+            migrationBuilder.AddColumn<DateTime>(
+                name: "CreatedAt",
+                table: "Leuze_Modules_Goal_Domain_Comments",
+                type: "datetime2",
+                nullable: false,
+                defaultValue: new DateTime(1, 1, 1, 0, 0, 0, 0, DateTimeKind.Unspecified));
+        }
+
+        protected override void Down(MigrationBuilder migrationBuilder)
+        {
+            migrationBuilder.DropColumn(
+                name: "CreatedAt",
+                table: "Leuze_Modules_Goal_Domain_Reviews");
+
+            migrationBuilder.DropColumn(
+                name: "CreatedAt",
+                table: "Leuze_Modules_Goal_Domain_GoalUpdates");
+
+            migrationBuilder.DropColumn(
+                name: "CreatedAt",
+                table: "Leuze_Modules_Goal_Domain_GoalItems");
+
+            migrationBuilder.DropColumn(
+                name: "OwnerLocked",
+                table: "Leuze_Modules_Goal_Domain_GoalItems");
+
+            migrationBuilder.DropColumn(
+                name: "SupervisorLocked",
+                table: "Leuze_Modules_Goal_Domain_GoalItems");
+
+            migrationBuilder.DropColumn(
+                name: "CreatedAt",
+                table: "Leuze_Modules_Goal_Domain_GoalDefinitions");
+
+            migrationBuilder.DropColumn(
+                name: "CreatedAt",
+                table: "Leuze_Modules_Goal_Domain_GoalDefinitionAreas");
+
+            migrationBuilder.DropColumn(
+                name: "CreatedAt",
+                table: "Leuze_Modules_Goal_Domain_Comments");
+        }
+    }
+}
diff --git a/src/Core/Infrastructure/Leuze.Core.Infrastructure.Persistence/Migrations/LeuzeDbContextModelSnapshot.cs b/src/Core/Infrastructure/Leuze.Core.Infrastructure.Persistence/Migrations/LeuzeDbContextModelSnapshot.cs
index a277899..b5de9ec 100644
--- a/src/Core/Infrastructure/Leuze.Core.Infrastructure.Persistence/Migrations/LeuzeDbContextModelSnapshot.cs
+++ b/src/Core/Infrastructure/Leuze.Core.Infrastructure.Persistence/Migrations/LeuzeDbContextModelSnapshot.cs
@@ -282,6 +282,9 @@ namespace Leuze.Core.Infrastructure.Persistence.Migrations
                         .ValueGeneratedOnAdd()
                         .HasColumnType("uniqueidentifier");
 
+                    b.Property<DateTime>("CreatedAt")
+                        .HasColumnType("datetime2");
+
                     b.Property<Guid>("CreatorId")
                         .HasColumnType("uniqueidentifier");
 
@@ -307,18 +310,52 @@ namespace Leuze.Core.Infrastructure.Persistence.Migrations
                     b.ToTable("Leuze_Modules_Goal_Domain_Comments");
                 });
 
-            modelBuilder.Entity("Leuze.Modules.Goal.Domain.Domains.GoalDefinition", b =>
+            modelBuilder.Entity("Leuze.Modules.Goal.Domain.Domains.GlobalDefinitionArea", b =>
                 {
                     b.Property<Guid>("Id")
                         .ValueGeneratedOnAdd()
                         .HasColumnType("uniqueidentifier");
 
+                    b.Property<DateTime>("CreatedAt")
+                        .HasColumnType("datetime2");
+
                     b.Property<Guid>("CreatorId")
                         .HasColumnType("uniqueidentifier");
 
                     b.Property<DateTime>("From")
                         .HasColumnType("datetime2");
 
+                    b.Property<DateTime>("To")
+                        .HasColumnType("datetime2");
+
+                    b.Property<double?>("VariCompanySuccess")
+                        .HasColumnType("float");
+
+                    b.HasKey("Id");
+
+                    b.HasIndex("CreatorId");
+
+                    b.ToTable("Leuze_Modules_Goal_Domain_GoalDefinitionAreas");
+                });
+
+            modelBuilder.Entity("Leuze.Modules.Goal.Domain.Domains.GoalDefinition", b =>
+                {
+                    b.Property<Guid>("Id")
+                        .ValueGeneratedOnAdd()
+                        .HasColumnType("uniqueidentifier");
+
+                    b.Property<DateTime>("CreatedAt")
+                        .HasColumnType("datetime2");
+
+                    b.Property<Guid>("CreatorId")
+                        .HasColumnType("uniqueidentifier");
+
+                    b.Property<double>("FinanceBase")
+                        .HasColumnType("float");
+
+                    b.Property<Guid>("GDAreaId")
+                        .HasColumnType("uniqueidentifier");
+
                     b.Property<string>("Name")
                         .IsRequired()
                         .HasMaxLength(255)
@@ -333,16 +370,15 @@ namespace Leuze.Core.Infrastructure.Persistence.Migrations
                     b.Property<bool>("SupervisorLocked")
                         .HasColumnType("bit");
 
-                    b.Property<DateTime>("To")
-                        .HasColumnType("datetime2");
-
-                    b.Property<decimal?>("Vari")
-                        .HasColumnType("decimal(18,2)");
+                    b.Property<double?>("VariProjectHours")
+                        .HasColumnType("float");
 
                     b.HasKey("Id");
 
                     b.HasIndex("CreatorId");
 
+                    b.HasIndex("GDAreaId");
+
                     b.HasIndex("OwnerId");
 
                     b.ToTable("Leuze_Modules_Goal_Domain_GoalDefinitions");
@@ -354,6 +390,9 @@ namespace Leuze.Core.Infrastructure.Persistence.Migrations
                         .ValueGeneratedOnAdd()
                         .HasColumnType("uniqueidentifier");
 
+                    b.Property<DateTime>("CreatedAt")
+                        .HasColumnType("datetime2");
+
                     b.Property<Guid>("CreatorId")
                         .HasColumnType("uniqueidentifier");
 
@@ -369,11 +408,17 @@ namespace Leuze.Core.Infrastructure.Persistence.Migrations
                         .HasMaxLength(255)
                         .HasColumnType("nvarchar(255)");
 
-                    b.Property<decimal>("PercentileFinal")
-                        .HasColumnType("decimal(18,2)");
+                    b.Property<bool>("OwnerLocked")
+                        .HasColumnType("bit");
+
+                    b.Property<double>("PercentileFinal")
+                        .HasColumnType("float");
 
-                    b.Property<decimal>("PercentileUser")
-                        .HasColumnType("decimal(18,2)");
+                    b.Property<double>("PercentileUser")
+                        .HasColumnType("float");
+
+                    b.Property<bool>("SupervisorLocked")
+                        .HasColumnType("bit");
 
                     b.HasKey("Id");
 
@@ -390,6 +435,9 @@ namespace Leuze.Core.Infrastructure.Persistence.Migrations
                         .ValueGeneratedOnAdd()
                         .HasColumnType("uniqueidentifier");
 
+                    b.Property<DateTime>("CreatedAt")
+                        .HasColumnType("datetime2");
+
                     b.Property<Guid>("CreatorId")
                         .HasColumnType("uniqueidentifier");
 
@@ -430,6 +478,9 @@ namespace Leuze.Core.Infrastructure.Persistence.Migrations
                         .IsRequired()
                         .HasColumnType("nvarchar(max)");
 
+                    b.Property<DateTime>("CreatedAt")
+                        .HasColumnType("datetime2");
+
                     b.Property<Guid>("CreatorId")
                         .HasColumnType("uniqueidentifier");
 
@@ -596,6 +647,17 @@ namespace Leuze.Core.Infrastructure.Persistence.Migrations
                     b.Navigation("Goal");
                 });
 
+            modelBuilder.Entity("Leuze.Modules.Goal.Domain.Domains.GlobalDefinitionArea", b =>
+                {
+                    b.HasOne("Leuze.Core.Domain.Domains.Users.DomainUser", "Creator")
+                        .WithMany()
+                        .HasForeignKey("CreatorId")
+                        .OnDelete(DeleteBehavior.Cascade)
+                        .IsRequired();
+
+                    b.Navigation("Creator");
+                });
+
             modelBuilder.Entity("Leuze.Modules.Goal.Domain.Domains.GoalDefinition", b =>
                 {
                     b.HasOne("Leuze.Core.Domain.Domains.Users.DomainUser", "Creator")
@@ -604,6 +666,12 @@ namespace Leuze.Core.Infrastructure.Persistence.Migrations
                         .OnDelete(DeleteBehavior.Cascade)
                         .IsRequired();
 
+                    b.HasOne("Leuze.Modules.Goal.Domain.Domains.GlobalDefinitionArea", "GDArea")
+                        .WithMany()
+                        .HasForeignKey("GDAreaId")
+                        .OnDelete(DeleteBehavior.Cascade)
+                        .IsRequired();
+
                     b.HasOne("Leuze.Core.Domain.Domains.Users.DomainUser", "Owner")
                         .WithMany()
                         .HasForeignKey("OwnerId")
@@ -612,6 +680,8 @@ namespace Leuze.Core.Infrastructure.Persistence.Migrations
 
                     b.Navigation("Creator");
 
+                    b.Navigation("GDArea");
+
                     b.Navigation("Owner");
                 });
 
diff --git a/src/Modules/Goal/Application/Leuze.Modules.Goal.Application.UI/Pages/Components/CreateGoalAside.razor b/src/Modules/Goal/Application/Leuze.Modules.Goal.Application.UI/Pages/Components/CreateGoalAside.razor
index 579dc35..de14ac6 100644
--- a/src/Modules/Goal/Application/Leuze.Modules.Goal.Application.UI/Pages/Components/CreateGoalAside.razor
+++ b/src/Modules/Goal/Application/Leuze.Modules.Goal.Application.UI/Pages/Components/CreateGoalAside.razor
@@ -18,7 +18,7 @@
     </div>
     <div class="review_detail_footer">
         <button @onclick="Create">Vytvořit</button>
-        <button>Zrušit</button>
+        <button @onclick="Close">Zrušit</button>
     </div>
 </aside>
 
@@ -125,9 +125,9 @@
 
     private string _aside;
 
-    public string Name { get; set; }
+    public string Name { get; set; } = "";
 
-    public string Description { get; set; }
+    public string Description { get; set; } = "";
 
     [Parameter]
     public bool Show { get; set; } = false;
@@ -143,16 +143,23 @@
 
     private async Task Create()
     {
+        if(Name == "")
+        {
+            toastService.ShowError("Nelze vytvořit cíl bez názvu!");
+            return;
+        }
         var response = await _mediator.Send(new CreateGoal.Command(DefinitionId, Name, Description));
 
         if (response.IsSuccess)
         {
             toastService.ShowSuccess("Cíl úspěšně vytvořen");
             await LoadGoalsInDefinitionView.InvokeAsync();
+            await Close();
+
+            Name = "";
+            Description = "";
         }
         else toastService.ShowError("Cíl se nepodařilo vytvořit");
-
-        await Close();
     }
 
     private async Task Close()
diff --git a/src/Modules/Goal/Application/Leuze.Modules.Goal.Application.UI/Pages/GoalDefinitionDetail.razor b/src/Modules/Goal/Application/Leuze.Modules.Goal.Application.UI/Pages/GoalDefinitionDetail.razor
index 434de4b..45830f4 100644
--- a/src/Modules/Goal/Application/Leuze.Modules.Goal.Application.UI/Pages/GoalDefinitionDetail.razor
+++ b/src/Modules/Goal/Application/Leuze.Modules.Goal.Application.UI/Pages/GoalDefinitionDetail.razor
@@ -5,10 +5,10 @@
 
 <div class="section_header">
     <div>
-        <h2>Název definice cílů</h2>
+        <h2>@_definition.Name</h2>
         <div class="definition_daterange">
             <i class="fal fa-clock"></i>
-            13.2.2021 - 12.2.2022
+            @_definition.GDArea.From.ToShortDateString() - @_definition.GDArea.To.ToShortDateString()
         </div>
     </div>
     <div class="header_buttons">
@@ -161,6 +161,8 @@ else
     [Parameter]
     public Guid Id { get; set; }
 
+    private GoalDefinition _definition = GoalDefinition.Default();
+
     public List<GoalItem> Goals { get; set; } = new();
 
     public Guid DetailId { get; set; } = default(Guid);
@@ -175,6 +177,16 @@ else
 
     private void CloseCreateAside() => ShowCreate = false;
 
+    private async Task GetDefinitionInfo()
+    {
+        var response = await _mediator.Send(new GetGoalDefinitionById.Query(Id));
+
+        if (response.IsSuccess)
+        {
+            _definition = response.Result.item;
+        }
+    }
+
     private async Task GetGoals()
     {
         var response = await _mediator.Send(new GetGoalsForDefinition.Query(Id));
@@ -188,6 +200,7 @@ else
     protected async override Task OnInitializedAsync()
     {
         await base.OnInitializedAsync();
+        await GetDefinitionInfo();
         await GetGoals();
     }
 
diff --git a/src/Modules/Goal/Application/Leuze.Modules.Goal.Application.UI/Pages/MyGoalDefinition.razor b/src/Modules/Goal/Application/Leuze.Modules.Goal.Application.UI/Pages/MyGoalDefinition.razor
index 91f1f40..c741ba1 100644
--- a/src/Modules/Goal/Application/Leuze.Modules.Goal.Application.UI/Pages/MyGoalDefinition.razor
+++ b/src/Modules/Goal/Application/Leuze.Modules.Goal.Application.UI/Pages/MyGoalDefinition.razor
@@ -13,6 +13,8 @@
         <tr>
             <th>Název</th>
             <th>Vytvořil</th>
+            <th>Splněnost cílů</th>
+            <th>Končí</th>
             <th>Akce</th>
         </tr>
         @foreach (var range in Definitions)
@@ -20,6 +22,8 @@
             <tr>
                 <td>@range.Name</td>
                 <td>@range.Creator.Name</td>
+                <td>@(range.Goals.Count > 0 ? range.Goals.Sum(item => item.PercentileFinal) / range.Goals.Count : 0)%</td>
+                <td>@range.GDArea.To.ToShortDateString()</td>
                 <td>
                     <div class="flex">
                         <div></div>
diff --git a/src/Modules/Goal/Application/Leuze.Modules.Goal.Application/CQRS/GoalDefinitions/Queries/GetGoalDefinitionById.cs b/src/Modules/Goal/Application/Leuze.Modules.Goal.Application/CQRS/GoalDefinitions/Queries/GetGoalDefinitionById.cs
index 0c289f7..ad5f008 100644
--- a/src/Modules/Goal/Application/Leuze.Modules.Goal.Application/CQRS/GoalDefinitions/Queries/GetGoalDefinitionById.cs
+++ b/src/Modules/Goal/Application/Leuze.Modules.Goal.Application/CQRS/GoalDefinitions/Queries/GetGoalDefinitionById.cs
@@ -11,36 +11,26 @@ using System.Text;
 using System.Threading;
 using System.Threading.Tasks;
 
-namespace Leuze.Modules.Goal.Application.CQRS.Goals.Commands
+namespace Leuze.Modules.Goal.Application.CQRS.Goals.Queries
 {
     public static class GetGoalDefinitionById
     {
-        public record Command(Guid GoalDefinitionId, string Name, string Description) : IBaseRequest<Response>;
+        public record Query(Guid GoalDefinitionId) : IBaseRequest<Response>;
 
-        public record Response(GoalItem item);
+        public record Response(GoalDefinition item);
 
 
-        public class Handler : IBaseRequestHandler<Command, Response>
+        public class Handler : IBaseRequestHandler<Query, Response>
         {
-            private readonly IGoalItemRepository _goalItemRepo;
             private readonly IGoalDefinitionRepository _goalDefinitionRepo;
-            private readonly AuthenticationStateProvider _authenticationStateProvider;
-            private readonly IDomainUserRepository _domainUserRepo;
 
-            public Handler(IGoalItemRepository goalItemRepo, IGoalDefinitionRepository goalDefinitionRepo, AuthenticationStateProvider authStateProvider, IDomainUserRepository domainUserRepo)
+            public Handler(IGoalDefinitionRepository goalDefinitionRepo)
             {
-                _goalItemRepo = goalItemRepo;
                 _goalDefinitionRepo = goalDefinitionRepo;
-                _authenticationStateProvider = authStateProvider;
-                _domainUserRepo = domainUserRepo;
             }
 
-            public async Task<RequestResponse<Response>> Handle(Command request, CancellationToken cancellationToken)
+            public async Task<RequestResponse<Response>> Handle(Query request, CancellationToken cancellationToken)
             {
-                //TODO: user muze byt null, ale to my nechceme!!!
-                var state = await _authenticationStateProvider.GetAuthenticationStateAsync();
-                var id = Guid.Parse(state.User!.FindFirst(ClaimTypes.NameIdentifier)!.Value);
-                var user = await _domainUserRepo.GetByIdAsync(id);
                 var goalDef = await _goalDefinitionRepo.GetByIdAsync(request.GoalDefinitionId);
 
                 if(goalDef == null)
@@ -48,11 +38,7 @@ namespace Leuze.Modules.Goal.Application.CQRS.Goals.Commands
                     return RequestResponse<Response>.CreateErrorResponse($"Goal definition with id: {request.GoalDefinitionId} not found!");
                 }
 
-                GoalItem item = new(goalDef, user, request.Name, request.Description);
-
-                await _goalItemRepo.AddAsync(item);
-
-                return RequestResponse<Response>.CreateSuccessResponse(new(item));
+                return RequestResponse<Response>.CreateSuccessResponse(new(goalDef));
             }
         }
 
diff --git a/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Domains/Comment.cs b/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Domains/Comment.cs
index 5d9698d..cb0479f 100644
--- a/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Domains/Comment.cs
+++ b/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Domains/Comment.cs
@@ -26,17 +26,29 @@ namespace Leuze.Modules.Goal.Domain.Domains
         }
 
         public Guid Id { get; private set; }
+        public DateTime CreatedAt { get; private set; } = DateTime.Now;
         public DomainUser Creator { get; private set; }
         public Guid CreatorId { get; private set; }
         public GoalItem Goal { get; private set; }
         public Guid GoalId { get; private set; }
         public string Text { get; private set; }
         public bool IsPrivate { get; private set; }
-        public bool IsChanged { get; set; }
+        public bool IsChanged { get; private set; }
 
         public void SetText(string text)
         {
             this.Text = text;
+            this.IsChanged = true;
+        }
+
+        public void SetPrivate()
+        {
+            this.IsPrivate = true;
+        }
+
+        public void SetPublic()
+        {
+            this.IsPrivate = false;
         }
     }
 }
diff --git a/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Domains/GlobalDefinitionArea.cs b/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Domains/GlobalDefinitionArea.cs
new file mode 100644
index 0000000..a582616
--- /dev/null
+++ b/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Domains/GlobalDefinitionArea.cs
@@ -0,0 +1,56 @@
+﻿using Leuze.Core.Domain.Domains;
+using Leuze.Core.Domain.Domains.Users;
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace Leuze.Modules.Goal.Domain.Domains
+{
+    public class GlobalDefinitionArea : BaseEntity
+    {
+        private GlobalDefinitionArea()
+        {
+
+        }
+
+        public GlobalDefinitionArea(DomainUser creator, DateTime from, DateTime to)
+        {
+            this.Creator = creator;
+            this.CreatorId = creator.UserId;
+            this.From = from;
+            this.To = to;
+            this.VariCompanySuccess = 0;
+        }
+
+        public static GlobalDefinitionArea Default()
+        {
+            return new GlobalDefinitionArea();
+        }
+
+        public Guid Id { get; private set; }
+        public DateTime CreatedAt { get; private set; } = DateTime.Now;
+        public DomainUser Creator { get; private set; }
+        public Guid CreatorId { get; private set; }
+        public DateTime From { get; private set; }
+        public DateTime To { get; private set; }
+        public double? VariCompanySuccess { get; private set; }
+
+
+        public void SetFrom(DateTime from)
+        {
+            this.From = from;
+        }
+
+        public void SetTo(DateTime to)
+        {
+            this.To = to;
+        }
+
+        public void SetVariCompanySuccess(double vari)
+        {
+            this.VariCompanySuccess = vari;
+        }
+    }
+}
